XdkWrl: GeoTouchSensor Class Reference

Home | Hierarchy | Members | Alphabetical | Related Pages

# GeoTouchSensor Class Reference
[Standard Node Types]

`#include <geotouchsensor.h>`

Inherits Node.

List of all members.

## Public Member Functions
| GeoTouchSensor (const char *name="")
virtual | ~GeoTouchSensor ()
virtual unsigned int | nbFields () const
virtual FieldHandle | field (const std::string &n)
virtual FieldHandle | field (unsigned int i)
virtual bool | isSetToDefaultValue (unsigned int i) const
virtual unsigned int | nbEventsIn () const
virtual EventInHandle | eventIn (const std::string &n)
virtual EventInHandle | eventIn (unsigned int i)
virtual unsigned int | nbEventsOut () const
virtual EventOutHandle | eventOut (const std::string &n)
virtual EventOutHandle | eventOut (unsigned int i)
const char * | typeName () const
virtual Node * | duplicate () const
virtual Node * | duplicate (std::map< const Node *, Node * > &) const
## Public Attributes
Exposed Fields
A field that is capable of receiving events via an eventIn to change its value(s), and generating events via an eventOut when its value(s) change.
SFBool | enabled
Fields
A property or attribute of a node. Each node type has a fixed set of fields. Fields may contain various kinds of data and one or many values. Each field has a default value.
SFNode | geoOrigin
MFString | geoSystem
Events In
EventIn< SFBool > | set_enabled
Events Out
EventOut< SFVec3f > | hitNormal_changed
EventOut< SFVec3f > | hitPoint_changed
EventOut< SFVec2f > | hitTexCoord_changed
EventOut< SFString > | hitGeoCoord_changed
EventOut< SFBool > | isActive
EventOut< SFBool > | isOver
EventOut< SFTime > | touchTime
EventOut< SFBool > | enabled_changed

## Detailed Description

Here is the documentation for this node type, from the ISO standard.

## 6.30 GeoTouchSensor

A GeoTouchSensor node tracks the location and state of a pointing device and detects when the user points at geometry contained by the GeoTouchSensor's parent group. This node provides the same functionality as a TouchSensor but also provides the ability to return the geospatial coordinate under the pointing device. This is an optionally-implemented VRML node that constitutes part of the VRML support for geospatial applications, see 4.15, Geospatial application support.

A GeoTouchSensor can be enabled or disabled by sending an event of value TRUE or FALSE to the enabled field. A disabled GeoTouchSensor does not track user input or send events.

The geoOrigin field is used to specify a local coordinate frame for extended precision as described in 4.15.5 Dealing with high-precision coordinates.

The geoSystem field is used to define the spatial reference frame and is described in 4.15.3, Encoding a spatial reference frame.

The eventOuts hitNormal_changed, hitPoint_changed, hitTexCoord_changed, isActive, isOver, and touchTime all have the same meaning as in the base VRML TouchSensor node.

The hitGeoCoord_changed eventOut is generated while the pointing device is pointing towards the GeoTouchSensor's geometry, i.e. when isOver is TRUE. It is a string containing the geospatial coordinate for the point of intersection between the pointing device's location and the underlying geometry. The value of the geoSystem string defines the spatial reference frame that the geospatial coordinate is output using. For example, given the default geoSystem value of "GD", the string will be in the format "<latitude> <longitude> <elevation>" (see 4.15.4, Encoding geospatial coordinates).

## Constructor & Destructor Documentation

GeoTouchSensor | ( | const char * | name = `""` | ) |

Construct a node with all its fields set to default value, which is equivalent to the code below:

      enabled = true;

~GeoTouchSensor | ( |  | ) | `[virtual]`

Virtual destructor, does nothing

## Member Function Documentation

unsigned int nbFields | ( |  | ) | const`[inline, virtual]`

Returns the number of fields (exposed or not) for this node type.

Implements Node.

wrl::Node::FieldHandle field | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the field named `n` of the node or a "unknown" typed handle if there is no such field. Valid names are:

- enabled
- geoOrigin
- geoSystem

Implements Node.

wrl::Node::FieldHandle field | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th field of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : enabled
- 1 : geoOrigin
- 2 : geoSystem This function is useful, with nbFields() if you want to traverse all fields of a Node.

Implements Node.

bool isSetToDefaultValue | ( | unsigned int | i | ) | const`[virtual]`

Implements Node.

unsigned int nbEventsIn | ( |  | ) | const`[inline, virtual]`

Returns the number of events in for this node type.

Implements Node.

wrl::Node::EventInHandle eventIn | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the event in named `n` of the node or a "unknown" typed handle if there is no such event. Valid names are:

- set_enabled

Implements Node.

wrl::Node::EventInHandle eventIn | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th event in of the node or a "unknown" typed handle if there is no such node. emarks This class has no eventIn. This function is useful, with nbEventsIn() if you want to traverse all events in of a Node.

Implements Node.

unsigned int nbEventsOut | ( |  | ) | const`[inline, virtual]`

Returns the number of events out for this node type.

Implements Node.

wrl::Node::EventOutHandle eventOut | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the event out named `n` of the node or a "unknown" typed handle if there is no such event. Valid names are:

- hitNormal_changed
- hitPoint_changed
- hitTexCoord_changed
- hitGeoCoord_changed
- isActive
- isOver
- touchTime
- enabled_changed

Implements Node.

wrl::Node::EventOutHandle eventOut | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th event out of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : hitNormal_changed
- 1 : hitPoint_changed
- 2 : hitTexCoord_changed
- 3 : hitGeoCoord_changed
- 4 : isActive
- 5 : isOver
- 6 : touchTime
- 7 : enabled_changed This function is useful, with nbEventsOut() if you want to traverse all events in of a Node.

Implements Node.

const char * typeName | ( |  | ) | const`[inline, virtual]`

Returns `"GeoTouchSensor"`. Useful for printing.

Implements Node.

wrl::Node * duplicate | ( |  | ) | const`[virtual]`

Returns a deep copy of this node, that is a fully independant node with all children (if any) also copied. This is mainly useful for instanciating protos.

Implements Node.

virtual Node* duplicate | ( | std::map< const Node *, Node * > & |  | ) | const`[virtual]`

Implements Node.

## Member Data Documentation

SFBool enabled

See Detailed Description for meaning of this field. Default value is set to

           enabled = true;

SFNode geoOrigin

See Detailed Description for meaning of this field. Default value is set to SFNode default value

MFString geoSystem

See Detailed Description for meaning of this field. Default value is set to

EventIn<SFBool> set_enabled

Set event associated to exposedField enabled

EventOut<SFVec3f> hitNormal_changed

See Detailed Description for meaning of this event.

EventOut<SFVec3f> hitPoint_changed

See Detailed Description for meaning of this event.

EventOut<SFVec2f> hitTexCoord_changed

See Detailed Description for meaning of this event.

EventOut<SFString> hitGeoCoord_changed

See Detailed Description for meaning of this event.

EventOut<SFBool> isActive

See Detailed Description for meaning of this event.

EventOut<SFBool> isOver

See Detailed Description for meaning of this event.

EventOut<SFTime> touchTime

See Detailed Description for meaning of this event.

EventOut<SFBool> enabled_changed

Changed event associated to exposedField enabled

Generated on 5 Jan 2007 with version 1.5.1. |